<template>
  <div>
    <section
      class="flex flex-col justify-center py-16 bg-white sm:px-6 lg:px-8"
    >
      <div class="sm:mx-auto sm:w-full sm:max-w-md">
        <div class="flex items-center justify-center w-full">
          <nuxt-link to="/" target="_parent">
            <Logo class="h-10" mode="dark" />
          </nuxt-link>
        </div>
      </div>

      <div class="mt-8 sm:mx-auto sm:w-full sm:max-w-md">
        <div class="px-4 py-8 bg-white shadow-lg sm:rounded-lg sm:px-10">
          <h2 class="mb-5 text-3xl font-semibold text-black">Sign-In</h2>
          <form class="grid grid-cols-2 gap-5 py-6">
            <div class="col-span-2">
              <label
                for="username"
                class="block text-sm font-medium text-black"
              >
                Username
              </label>
              <div class="mt-1">
                <input
                  id="username"
                  v-model="log.username"
                  name="username"
                  type="text"
                  placeholder=""
                  autocomplete="username"
                  required
                  class="w-full form-input"
                  :class="[{ 'border-primary-200': error }]"
                />
              </div>
            </div>

            <div class="col-span-2">
              <label
                for="password"
                class="block text-sm font-medium text-black"
              >
                Password
              </label>
              <div class="mt-1">
                <input
                  id="password"
                  v-model="log.password"
                  name="password"
                  type="password"
                  autocomplete="current-password"
                  required
                  class="w-full form-input"
                  :class="[{ 'border-primary-200': error }]"
                />
              </div>
            </div>

            <div class="flex items-center justify-between col-span-2">
              <div class="flex items-center">
                <input
                  id="remember_me"
                  v-model="log.rememberMe"
                  name="remember_me"
                  type="checkbox"
                  class="text-primary-400 form-checkbox"
                />
                <label
                  for="remember_me"
                  class="block ml-2 text-sm font-medium text-black"
                >
                  Remember me
                </label>
              </div>

              <!-- <div class="text-sm">
                <a
                  href="#"
                  class="font-medium text-primary-300 hover:text-primary-400"
                >
                  Forgot your password?
                </a>
              </div> -->
            </div>

            <div class="col-span-2">
              <button
                type="submit"
                class="btn primary large"
                @click.prevent="logIn"
              >
                <span v-if="!loading"> Sign in </span>
                <span v-else>
                  <i class="text-xl text-white bx bx-loader-alt bx-spin"></i>
                </span>
              </button>
            </div>

            <div
              v-if="error"
              class="flex items-center justify-center col-span-2 my-5"
            >
              <div class="text-center">
                <i class="text-5xl bx bx-error text-primary-200"></i>
              </div>
              <div class="ml-5">
                <h2 class="mb-1 font-semibold text-1xl text-primary-200">
                  A problem has occurred
                </h2>
                <p class="text-sm">
                  {{ error.message }}
                </p>
              </div>
            </div>
            <!-- TODO add help -> faqs -->
          </form>
        </div>
        <div class="my-6">
          <div class="relative">
            <div class="absolute inset-0 flex items-center">
              <div class="w-full border-t border-secondary-300"></div>
            </div>
            <div class="relative flex justify-center text-sm">
              <span class="px-2 bg-white text-secondary-300">
                New to Mōlygo?
              </span>
            </div>
          </div>
        </div>
        <nuxt-link to="/register" target="_parent" class="btn secondary base">
          Create your Mōlygo account
        </nuxt-link>
      </div>
    </section>
  </div>
</template>

<script>
import Logo from '~/components/branding/Logo'
// import logIn from '~/apollo/mutations/user/logIn.gql'

export default {
  components: {
    Logo,
  },
  layout: 'full',
  data() {
    return {
      log: {
        username: null,
        password: null,
        rememberMe: false,
      },
      error: null,
      loading: false,
    }
  },
  computed: {
    redirectTo() {
      return this.$route.params.redirectTo
    },
  },
  mounted() {
    if (this.$store.state.auth.customer) {
      this.$router.push('/')
    }
  },
  methods: {
    logIn() {
      try {
        this.loading = true
        localStorage.removeItem('log')
        this.$store.dispatch('auth/logIn', {
          username: this.log.username,
          password: this.log.password,
          clientMutationId: Math.random().toString(36).substring(2),
          redirectTo: this.redirectTo || '/',
        })
      } catch (error) {
        this.loading = false
        this.log.username = this.log.password = ''
        document.getElementById('username').focus()
        this.error = {
          log: error,
          message: 'The password or username is incorrect.',
        }
      }
    },
  },
}
</script>
